<?php
// Hinweis: Dies ist nur eine Teildatei, die von einer anderen inkludiert wird.
// den HTML-Head und den Datenbankzugriff müssen Sie selber ergänzen.
// Achtung: Das Format hier ist UTF-8, kann aber bei entsprechender Umwandlung auch mit iso-8859-1 laufen. Für die Datenbank ist das nicht wichtig.
// der Datenbankconnect wird bei mir über die Variable $conn angesprochen.
// Als Sprungmarke nutze ich $q, welche per $_POST['q'] oder $_REQUEST['q'] ausgelesen werden muss

if ($q == "basalrate")
{
	?>
	<h3>Basalratenrechner I</h3>
	für die Berechnung des FPE anhand von Fett, Eiweiß und der Menge und der erforderlichen Pumpeneinstellungen<br />
	<h3>Diese Lösung funktioniert nur bei jeweils 1 Mahlzeit mit den FPE-Werten!</h3>
	Das Zusammenaddieren mehrerer unterschiedlicher Produkte und Nährwertangaben ist bei dieser Berechnung nur für Pumpen möglich, wo man den FPE direkt als Verlängerungsbolus eingeben kann, nicht aber über die temporäre Basalrate. Oder man errechnet das mit dem Taschenrechner von Hand und gibt das Ergebnis unten bei Basalratenrechner II ein.<br />
	Wie das in Fällen von mehreren Angaben mit verschiedenen Werten (Fett, Protein, Menge) gleichzeitig mit der Umrechnung auf die temporäre Basalrate funktioniert, entzieht sich meiner Kenntnis.<br />
	Vielleicht eilt mir ja ein schlauer Mathematiker mal zu Hilfe.<br />
	Mein bisheriger Kenntnisstand ist: Bei mehreren Produkten muss die FPE-Berechnung für jedes Produkt einzeln durchgeführt und dann ein Mittelwert ermittelt werden bzw. eine Schätzung in Abstimmung mit der Dauer erfolgen, weil die Wirkung und Wirkungsdauer jeder Mahlzeit aufgrund der unterschiedlichen Fett/Eiweiß- + Mengenangaben unterschiedlich ist!<br />
	Wenn man die Werte (insbesondere die Gramm) einfach zusammenzählt, kommen falsche Werte heraus!<br />
	<b>In diesem Falle ist es besser, man rechnet die Werte mit dem Taschenrechner aus und benutzt dann Formular "Basalratenrechner II" weiter unten.</b><br /><br />

	Diese Berechnung bezieht sich auf die vorhergehende Seite <a href="?q=fpe"><b>Berechnung Fett-Protein-Einheiten (FPE)</b></a><br />

	<form method="post">
	<input type="hidden" name="q" value="temp_basalrate_berechnen" />
	Bei den Eingabefeldern Fett und Eiweiß kann bei der Eingabe auch Komma statt Punkt verwendet werden!<br /><br />

	<b>Hinweis:</b> Hier wird der Weg der Berechnung über die <b>temporäre Basalrate</b> gewählt. <br />
	Die Berechnung ist etwas aufwändiger. Deshalb dieses Formular hier. <br />
	<span style="color:red">Das gilt vor allem für Pumpen, wo die Eingabe eines Langzeitbolus den Kurzzeitbolus während dieser Zeit blockiert. <br />
	Normalerwesie reicht es aus, <b>die errechneten FPE auf die Zeitdauer als Langzeitbolus</b> zu verabreichen.</span> <br />
	Die komplizierte Umrechnung auf die Prozent entfällt in diesem Fall :-) .<br />
	<h3>Diese Werte sind MEINE Werte! Bei Ihnen ist die Basalrate ja wieder ganz anders!</h3>
	Weitere technische Infos auf der nächsten Seite und unter <a href="?q=technische_daten"><b>Technische Daten</b></a><br /><br /><br />

	<b>Essen:</b><br />
	Fettanteil pro 100gr: <input type="number" step="0.1" name="fett" required="required" size="4" value="<?php echo $_REQEUEST['fett']?>" min="0.1" /><br />
	Eiweißanteil pro 100gr: <input type="number" step="0.1" name="eiweiss" required="required" size="4" value="<?php echo $_REQEUEST['eiweiss']?>" min="0.1" /><br />
	Gesamtmenge der Nahrung (Gramm): <input type="number" name="gesamtmenge" required="required" size="5" value="<?php echo $_REQEUEST['gesamtmenge']?>" min="1" /><br /><br />

	<b>Pumpe:</b><br />
	Momentaner persönlicher Korrekturfaktor ( für Gesamtsumme der FPE / 100 * 0,7 bei mir) : <input type="number" step="0.001" value="0.007" name="korrekturfaktor" size="5" required="required" min="0" /><br />
	Uhrzeit ab: <input type="number" name="von" value="<?php echo date("H")?>" size="2" required="required" max="24" /> Uhr<br />
	<!-- Die Dauer wird automatisch berechnet.<br /><br / -->
	Die Dauer ist ein Schätzwert und kann eigentlich erst nach der FPE-Berechnung ermittelt werden. Ein guter Wert ist "2".<br />
	Vorsicht !!! Die Dauer kann hier angegeben werden, sollte aber errechnet werden (deshalb "0") : <input type="number" name="dauer" required="required" value="0" size="3" step="1" min="0" /> Stunden<br /><br />
	<input type="submit" value="berechnen" />
	</form>
	<br /><hr /><br />



	<h3>Basalratenrechner II</h3>
	Diese Version ist für Berechnungen gedacht, wo der FPE bereits bekannt ist, weil er entweder oben EINZELN ausgerechnet wurde, oder mit dem Taschenrechner "von Hand".<br /><br />
	Hier muss nur der FPE-Wert eingegeben werden. Das Programm ermittelt dann die temporäre Basalrate.<br />
	Deshalb ist dieser Bereich hier nur für Nutzer interessant, die den Langzeitbolus nur über die temporätre Basalrate einstellen können weil der Langzeitbolus während seiner Dauer keinen Kurzzeitbolus mehr zulässt.<br /><br />

	Auch diese Berechnung bezieht sich auf die vorhergehende Seite <a href="?q=fpe"><b>Berechnung Fett-Protein-Einheiten (FPE)</b></a><br /><br />

	<form method="post">
	<input type="hidden" name="q" value="temp_basalrate_berechnen2" />
	<br /><b>Fett-Protein-Einheit (FPE):</b>
	<input type="text" name="fpe" required="required" size="5" value="<?php echo $_REQEUEST['fpe']?>" min="1" /><br /><br />

	<b>Pumpe:</b><br />
	Momentaner persönlicher Korrekturfaktor ( für Gesamtsumme der FPE / 100 * 0,7 bei mir) : <input type="number" step="0.001" value="0.007" name="korrekturfaktor" size="5" required="required" min="0" /><br />
	Uhrzeit ab: <input type="text" name="von" value="<?php echo date("H")?>" size="2" required="required" max="24" /> Uhr<br />
	<!-- Die Dauer wird automatisch berechnet.<br /><br / -->
	Vorsicht !!! Die Dauer kann hier angegeben werden, sollte aber errechnet werden (deshalb "0") : <input type="number" name="dauer" required="required" value="0" size="3" step="1" min="0" /> Stunden<br /><br />
	<input type="submit" value="berechnen" />
	</form>
	<br /><br /><br />
	<?php
}

if ($q == "temp_basalrate_berechnen")
{
	$fett = (float) str_replace(",",".", makesafe($_REQUEST['fett']));
	$eiweiss = (float) str_replace(",",".", makesafe($_REQUEST['eiweiss']));
	$gesamtmenge = (float) makesafe($_REQUEST['gesamtmenge']);

	$korrekturfaktor = (float) makesafe($_REQUEST['korrekturfaktor']);
	$von = makesafe($_REQUEST['von']);
	$dauer = str_replace(",",".", makesafe($_REQUEST['dauer']));

	// Fett-Protein-Einheit
	//echo "<br />FPE:<br />".
	$fpe = round((($fett * 9 * $gesamtmenge / 100) + ($eiweiss * 4 * $gesamtmenge / 100)) * $korrekturfaktor, 1);

	// Dauer nur wenn oben nicht angegeben. Dann Standard 2 Stunden.
	// Gesamtdauer muss wegen Datenbankabfrage (Limit) Integer sein
	// echo "<br />Dauer: ".$dauer;
	if (!$dauer)
		$gesamtdauer = floor($fpe) + 2; // abgerundet + 2 Stunden
	else
		$gesamtdauer = floor($fpe) + $dauer;

	// der errechnete FPE-Wert muss jetzt auf die Dauer aufgeteilt werden und die Anzahl von "Dauer" aus der DB ermittelt werden
	// echo "<br />".
	$sql = "SELECT menge FROM diab_basal WHERE von >= ".$von." LIMIT ".$gesamtdauer;
	$r = mysqli_query($conn, $sql);

	$basalmenge_waehrend_dauer = 0;
	while ($d = mysqli_fetch_array($r))
	{
		$basalmenge_waehrend_dauer += $d['menge'];
	}

	// jetzt den fpe dazu addieren:
	// echo "<br />Gesamtbasal incl fpe:<br />".
	$gesamtbasal = $fpe + $basalmenge_waehrend_dauer;

	// das jetzt mit der Normalmenge prozentual vergleichen:
	// echo "<br />Prozentwert: <br />".
	$erg = round($gesamtbasal / $basalmenge_waehrend_dauer * 100, 0);

	// Ausgabe:
	?>
	<h3>Ergebnis:</h3>

	<b>Essen:</b><br />
	Fettanteil pro 100gr: <b><?php echo $fett?></b><br />
	Eiweißanteil pro 100gr: <b><?php echo $eiweiss?></b><br />
	Gesamtmenge der Nahrung (Gramm): <b><?php echo $gesamtmenge?></b><br /><br />

	<b>Pumpe:</b><br />
	Momentaner persönlicher Korrekturfaktor: <b><?php echo $korrekturfaktor?></b><br />
	Uhrzeit ab: <?php echo $von?> Uhr<br />

	<h4 style="color:red; border-collapse:collapse;">Fett-Protein-Einheiten = <?php echo $fpe?></h4>
	Gesamtdauer = <b><?php echo $gesamtdauer?> Stunden</b> (FPE abgerundet + <?php echo ($dauer==0?"2":$dauer)?> Stunde(n))<br />
	Standard-Basalmenge während dieser Zeit (aus Datenbank): <b><?php echo $basalmenge_waehrend_dauer?></b><br /><br />
	<b>Erhöhe die temporäre Basalrate für <?php echo $gesamtdauer?> Stunden auf <?php echo $erg?>%</b><br /><br />
	<h4>Achtung! Das sind nur ungefähre Richtwerte. Bitte nicht blindlings übernehmen sondern je nach Situation variieren!</h4>

	<!-- Der Berechnung liegen folgende Werte für die <b>T-Slim:X2</b> zugrunde, die im Gegensatz zu anderen Pumpen nur <b>16 Zeitfenster statt 24</b> hat und daher die restlichen Stunden bei Einstellung der Basalrate geschätzt werden müssen.<br />
	<b>Bei anderen Pumpen, wie z.B Medtronic 640G reicht es aus, die errechneten FPE auf die Dauer per Langzeitbolus zu verteilen.</b><br /><br />
	-->

	<h4>Diese errechneten <span style="color:red"><?php echo $fpe?> FPE</span> müssen auf die Dauer von <span style="color:red"><?php echo $gesamtdauer?> Stunden</span> per Langzeitbolus verteilt werden.</h4><br />

	<?php
	include "basaltabelle.inc.php";
}

if ($q == "temp_basalrate_berechnen2")
{
	$fpe = (float) str_replace(",",".", makesafe($_REQUEST['fpe']));

	$korrekturfaktor = (float) makesafe($_REQUEST['korrekturfaktor']);
	$von = makesafe($_REQUEST['von']);
	$dauer = str_replace(",",".", makesafe($_REQUEST['dauer']));

	// Dauer nur wenn oben nicht angegeben. Dann Standard 2 Stunden.
	// Gesamtdauer muss wegen Datenbankabfrage (Limit) Integer sein
	// echo "<br />Dauer: ".$dauer;
	if (!$dauer)
		$gesamtdauer = floor($fpe) + 2; // abgerundet + 2 Stunden
	else
		$gesamtdauer = floor($fpe) + $dauer;

	// echo "<br />".
	$sql = "SELECT menge FROM diab_basal WHERE von >= ".$von." LIMIT ".$gesamtdauer;
	$r = mysqli_query($conn, $sql);

	$basalmenge_waehrend_dauer = 0;
	while ($d = mysqli_fetch_array($r))
	{
		$basalmenge_waehrend_dauer += $d['menge'];
	}

	// jetzt den fpe dazu addieren:
	// echo "<br />Gesamtbasal incl fpe:<br />".
	$gesamtbasal = $fpe + $basalmenge_waehrend_dauer;

	// das jetzt mit der Normalmenge prozentual vergleichen:
	// echo "<br />Prozentwert: <br />".
	$erg = round($gesamtbasal / $basalmenge_waehrend_dauer * 100, 0);

	// Ausgabe:
	?>
	<h3>Ergebnis der Berechnung bei bekannter FPE</h3>

	<b>Pumpe:</b><br />
	Momentaner persönlicher Korrekturfaktor: <b><?php echo $korrekturfaktor?></b><br />
	Uhrzeit ab: <?php echo $von?> Uhr<br />

	<b>Fett-Protein-Einheiten = <?php echo $fpe?></b><br />
	Gesamtdauer = <b><?php echo $gesamtdauer?> Stunden</b> (FPE abgerundet + <?php echo ($dauer==0?"2":$dauer)?> Stunde(n))<br />
	Standard-Basalmenge während dieser Zeit (aus Datenbank): <b><?php echo $basalmenge_waehrend_dauer?></b><br /><br />
	<b>Erhöhe die temporäre Basalrate für <?php echo $gesamtdauer?> Stunden auf <?php echo $erg?>%</b><br /><br />
	<h4 style="color:red">Achtung! Das sind nur ungefähre Richtwerte. Bitte nicht blindlings übernehmen!</h4>

	Der Berechnung liegen folgende Werte für die <b>T-Slim:X2</b> zugrunde, die im Gegensatz zu anderen Pumpen nur <b>16 Zeitfenster statt 24</b> hat und daher die restlichen Stunden bei Einstellung der Basalrate geschätzt werden müssen.<br />
	<b>Bei anderen Pumpen, wie z.B Medtronic 640G reicht es aus, die errechneten FPE auf die Dauer per Langzeitbolus zu verteilen.</b><br /><br />

	<?php
	include "basaltabelle.inc.php";

}
?>
